// *********************************************************************
//  Created with bc9Basic - BASIC To C/C++ Translator (V) 9.2.6.0 (2017/02/05)
//       The bc9Basic translator (bc9.exe) was compiled with
//                           g++ (tdm64-1) 5.1.0
// ----------------------------------------------------------------------
//                 BCX (c) 1999 - 2009 by Kevin Diggins
// *********************************************************************
//              Translated for compiling with a C Compiler
//                           On MS Windows
// *********************************************************************
#ifndef _WIN32_DCOM
#define _WIN32_DCOM
#endif
#include <windows.h>    // Win32 Header File 
#include <windowsx.h>   // Win32 Header File 
#include <commctrl.h>   // Win32 Header File 
#include <commdlg.h>    // Win32 Header File 
#include <mmsystem.h>   // Win32 Header File 
#include <shellapi.h>   // Win32 Header File 
#include <shlobj.h>     // Win32 Header File 
#include <richedit.h>   // Win32 Header File 
#include <objbase.h>    // Win32 Header File 
#include <ocidl.h>      // Win32 Header File 
#include <winuser.h>    // Win32 Header File 
#include <olectl.h>     // Win32 Header File 
#include <oaidl.h>      // Win32 Header File 
#include <ole2.h>       // Win32 Header File 
#include <oleauto.h>    // Win32 Header File 
#include <winsock.h>    // Win32 Header File 
#include <wininet.h>    // Win32 Header File 
#include <uxtheme.h>    // Win32 Header File 
#include <psapi.h>      // Win32 Header File 
#include <shlwapi.h>      // Win32 Header File 
#ifndef __TINYC__       // No Tiny C support
#include <urlmon.h>     // Win32 Header File 
#endif
#include <process.h>    // dos
#include <direct.h>     // dos
#include <io.h>         // dos
#include <conio.h>      // dos
#include <wchar.h>      // dos/linux 
#include <ctype.h>      // dos/linux
#include <math.h>       // dos/linux
#include <stdio.h>      // dos/linux
#include <string.h>     // dos/linux
#include <stddef.h>     // dos/linux
#include <stdlib.h>     // dos/linux
#include <setjmp.h>     // dos/linux
#include <time.h>       // dos/linux
#include <stdarg.h>     // dos/linux
#include <fcntl.h>      // dos/linux
#include <sys/types.h>
#include <sys/stat.h>


// ***************************************************
// Compiler Defines
// ***************************************************

// C++
#if defined( __cplusplus )
#define overloaded
#define C_EXPORT EXTERN_C __declspec(dllexport)
#define C_IMPORT EXTERN_C __declspec(dllimport)
#define BEGIN_EXTERN_C		extern "C" {
#define END_EXTERN_C		}
#else
#define C_EXPORT __declspec(dllexport)
#define C_IMPORT __declspec(dllimport)
#endif


// Microsoft VC++
#ifndef DECLSPEC_UUID
#if (_MSC_VER >= 1100) && defined ( __cplusplus )
#define DECLSPEC_UUID(x)    __declspec(uuid(x))
#else
#define DECLSPEC_UUID(x)
#endif
#endif

#define stricmp _stricmp

// *************************************************
// Instruct Linker to Search Object/Import Libraries
// *************************************************
#pragma comment(lib,"kernel32.lib")
#pragma comment(lib,"user32.lib")
#pragma comment(lib,"gdi32.lib")
#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"advapi32.lib")
#pragma comment(lib,"winspool.lib")
#pragma comment(lib,"shell32.lib")
#pragma comment(lib,"ole32.lib")
#pragma comment(lib,"oleaut32.lib")
#pragma comment(lib,"uuid.lib")
#pragma comment(lib,"odbc32.lib")
#pragma comment(lib,"odbccp32.lib")
#pragma comment(lib,"winmm.lib")
#pragma comment(lib,"comdlg32.lib")
#pragma comment(lib,"imagehlp.lib")
#pragma comment(lib,"version.lib")
#pragma comment(lib,"wininet.lib")
#pragma comment(lib,"urlmon.lib")
#pragma comment(lib,"uxtheme.lib")
#pragma comment(lib,"shlwapi.lib")
// *************************************************
// End of Object/Import Libraries To Search
// *************************************************

// *************************************************
//        User's GLOBAL ENUM blocks
// *************************************************

// *************************************************
//            System Defined Constants
// *************************************************

typedef const char* ccptr;
#define CCPTR const char*
#define cfree free
#define EQU ==
#define NOT_USED(x) if(x);
#define CTLHNDL(id) GetDlgItem(hWnd,id)
char   *g_cptr_;  // dummy var for not used returns
unsigned int  g_dum1_;  // dummy var for not used returns
int g_dum_int;		// dummy int var for not used returns
#define cSizeOfDefaultString 2048

// *************************************************
//            User Defined Constants
// *************************************************


// *************************************************
//               Standard Prototypes
// *************************************************

// *************************************************
// Late binding COM support section
// (c) Ljubisa Knezevic 2004-2009, ljube@blic.net
// *************************************************
#include <unknwn.h>
#include <tchar.h>
// types used by Late binding COM support
#define COM_STACK_SIZE  64
#ifndef CON_VARBOOL2BOOL
#define CON_VARBOOL2BOOL(b) ((BOOL)(b ? TRUE : FALSE))
#endif

typedef struct _OBJECT
{
    IUnknown*  p_unknown;
    VARIANT    pObjects[COM_STACK_SIZE];
    BOOL       pStatus;
    int        ipointer;
} OBJECT, *LPOBJECT;

typedef struct _PARAM_VARARRAY
{
    VARIANT  pParams[COM_STACK_SIZE];
} PARAM_VARARRAY, *LPPARAM_VARARRAY;

char* BCX_TmpStr(size_t, size_t , int );
char*   remain (const char*, const char*);
char*   join (int, ... );
char* enc (const char*, int , int );
BOOL    Exist   (const char*);
BOOL    Exist_A (char*);
BOOL    Exist_B (char*);
void    Pause (void);
HRESULT BCX_COM_AS2WS(LPCSTR ansi_string, UINT code_page );
HRESULT BCX_COM_WS2AS(LPCWSTR wide_string, UINT code_page );
//  COM functions used internally by BCX
void     bcx_ole_initialize(void);
void     bcx_ole_uninitialize(void);
void     bcx_catch_hr_error_desc(HRESULT hr, const TCHAR* extra_info);
DISPID   bcx_get_DISPID_of_dispatch(IDispatch* lpDispatch, LPOLESTR comsegment);
void     bcx_get_next_dispatch(OBJECT* object, LPOLESTR comsegment);
void     bcx_invoke_helper(OBJECT* object, const LPOLESTR comsegment, WORD wFlags, VARIANT *pvResult);
void bcx_build_exception_info(HRESULT hr, EXCEPINFO* pexcep , UINT uiArgErr );
void     bcx_clean_parameter_list(void);
void     bcx_reset_dispatch_chain(OBJECT* object);
void     bcx_create_safe_array(void);
// public COM support functions >>>
void     BCX_SetNothing(OBJECT* object);
HRESULT  BCX_GET_COM_ERROR_CODE(void);
char*    BCX_GET_COM_ERROR_DESC(void);
BOOL     BCX_GET_COM_SUCCESS(void);
BOOL     BCX_GET_COM_STATUS(OBJECT* object);
void     BCX_SHOW_COM_ERRORS(BOOL Show_err);
void     BCX_CreateObject(TCHAR* objname, OBJECT* obj);
// <<< public COM support functions
void     BCX_COM_FREE_TEMP_ANSI_STRING(void);
void     BCX_COM_FREE_TEMP_WIDE_STRING(void);

// *************************************************
//                System Variables
// *************************************************

// *************************************************
//          User Defined Types, Unions and Classes
// *************************************************

/* <--UNICODE AWARE-->  */
// global vars used by late binding COM support
static PARAM_VARARRAY bcx_static_param_list;
static _TCHAR bcx_last_com_error_holder[4096];
static _TCHAR bcx_last_com_error_indicator[64];
static int bcx_param_list_index_p = 0;
static VARIANT bcx_temp_result_variant;
static HRESULT bcx_last_com_HRESULT;
static BOOL bcx_ole_initialized = FALSE;
static int  bcx_ole_objects_count = 0;
static int  bcx_force_reset_chain = 0;
static BOOL BCX_COM_ERROR = FALSE;
static BOOL bSHOW_BCX_COM_ERROR = FALSE;
static SAFEARRAY * bcx_safe_array_pointer_psa = NULL;
static LPOLESTR bcx_temp_wide_string_pointer = NULL;
static char* bcx_temp_ans_string_pointer = NULL;
static ULONG bcx_temp_wide_string_buffer_size = 0;
static ULONG bcx_temp_ans_string_buffer_size = 0;
static BOOL bcx_com_get_enumerator_intf = FALSE;
static int bcx_preserve_dispatch_storage[ 32];
static int bcx_preserve_dispatch_storage_index = 0;
static int bcx_preserve_dispatch_at_offset = 0;


/* >--UNICODE AWARE--<  */

// *************************************************
//            User Global Variables
// *************************************************

static PCHAR   *g_argv;
static int     g_argc;
static OBJECT  objShell;
static OBJECT  objShortcut;
static char    str1[cSizeOfDefaultString];
static char    strTargetPathx86[cSizeOfDefaultString];
static char    SWorkx86[cSizeOfDefaultString];
static char    SArgux86[cSizeOfDefaultString];
static char    strTargetPathx64[cSizeOfDefaultString];
static char    SWorkx64[cSizeOfDefaultString];
static char    SArgux64[cSizeOfDefaultString];


// *************************************************
//            User Global Initialized Arrays
// *************************************************



// *************************************************
//                 Runtime Functions
// *************************************************

#ifndef BCXTmpStrSize
#define BCXTmpStrSize  2048
#endif
char *BCX_TmpStr (size_t Bites, size_t  iPad, int iAlloc)
{
    static int   StrCnt;
    static char *StrFunc[BCXTmpStrSize];
    StrCnt = (StrCnt + 1) & (BCXTmpStrSize - 1);
    if(StrFunc[StrCnt]) {
        free (StrFunc[StrCnt]);
        StrFunc[StrCnt] = NULL;
    }
#if defined BCX_MAX_VAR_SIZE
    if(Bites * sizeof(char) > BCX_MAX_VAR_SIZE)
    {
        printf("Buffer Overflow caught in BCX_TmpStr - requested space of %d EXCEEDS %d\n", (int)(Bites * sizeof(char)), BCX_MAX_VAR_SIZE);
        abort();
    }
#endif
    if(iAlloc) StrFunc[StrCnt] = (char*)calloc(Bites + iPad + 1, sizeof(char));
    return StrFunc[StrCnt];
}


char *remain (const char *mane, const char *mat)
{
    char *p = strstr((char*)mane, (char*)mat);
    if(p)
    {
        p += (strlen(mat));
        return p;
    }
    return (char*)mane;
}


char *enc (const char *A, int L, int R)
{
    int tmplen = strlen(A);
    char *BCX_RetStr = BCX_TmpStr(tmplen + 3, 1, 1);
    memcpy(BCX_RetStr + 1, A, tmplen);
    *BCX_RetStr = (char)((L == 0) ? 34 : L);
    BCX_RetStr[++tmplen] = (char)((R == 0) ? *BCX_RetStr : R);
    BCX_RetStr[++tmplen] = 0;
    return BCX_RetStr;
}


char * join(int n, ...)
{
    int i = n, tmplen = 0;
    char *s_;
    char *strtmp;
    va_list marker;
    va_start(marker, n); // Initialize variable arguments
    while(i-- > 0)
    {
        s_ = va_arg(marker, char *);
        if(s_) tmplen += strlen(s_);
    }
    strtmp = BCX_TmpStr(tmplen, 1, 1);
    va_end(marker); // Reset variable arguments
    i = n;
    va_start(marker, n); // Initialize variable arguments
    while(i-- > 0)
    {
        s_ = va_arg(marker, char *);
        if(s_) strcat(strtmp, s_);
    }
    va_end(marker); // Reset variable arguments
    return strtmp;
}


void Pause(void)
{
    printf("\n%s\n", "Press any key to continue...");
    _getch();
}


BOOL Exist (const char *szFilePath)
{
    if(strchr(szFilePath, '*') || strchr(szFilePath, '?'))
        return Exist_A ((char*)szFilePath);
    return Exist_B ((char*)szFilePath);
}

BOOL Exist_A (char *szFilePath)
{
    WIN32_FIND_DATA W32FindData;
    HANDLE rc;
    rc = FindFirstFile(szFilePath, &W32FindData);
    if(rc == INVALID_HANDLE_VALUE) return FALSE;
    FindClose(rc);
    return TRUE;
}

BOOL Exist_B (char *szFilePath)
{
    DWORD ret;
    ret = GetFileAttributes(szFilePath);
    if (ret != 0xffffffff) return TRUE;
    return FALSE;
}


/* <--UNICODE AWARE-->  */
HRESULT  BCX_GET_COM_ERROR_CODE(void)
{
    return bcx_last_com_HRESULT;
}


_TCHAR*    BCX_GET_COM_ERROR_DESC(void)
{
    return bcx_last_com_error_holder;
}


BOOL     BCX_GET_COM_SUCCESS(void)
{
    return (!BCX_COM_ERROR);
}


void     BCX_SHOW_COM_ERRORS(BOOL Show_err)
{
    bSHOW_BCX_COM_ERROR = Show_err;
}


void bcx_ole_initialize(void)
{
    if (bcx_ole_initialized) return;
#ifdef __BCX_MULTITHREADED__
    bcx_last_com_HRESULT = CoInitializeEx(NULL, COINIT_MULTITHREADED);

#else
    bcx_last_com_HRESULT = CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);

#endif
    if (SUCCEEDED(bcx_last_com_HRESULT))
    {
        bcx_ole_initialized = TRUE;
        VariantInit(&bcx_temp_result_variant);
        atexit(bcx_ole_uninitialize);
        bcx_preserve_dispatch_storage[0] = 0;
        bcx_preserve_dispatch_storage_index = 0;

        if (bcx_temp_wide_string_pointer) CoTaskMemFree((void*)bcx_temp_wide_string_pointer);

        bcx_temp_wide_string_pointer = (LPOLESTR)CoTaskMemAlloc( 2048);

        if (NULL == bcx_temp_wide_string_pointer)
        {
            bcx_temp_wide_string_buffer_size = 0;
            bcx_last_com_HRESULT =  E_OUTOFMEMORY;
            bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("Mem Allocation of temp_wide_variable Failed in CoInitializeEx!"));
            return;
        }

        bcx_temp_wide_string_buffer_size =  2048;

        if (bcx_temp_ans_string_pointer) free(bcx_temp_ans_string_pointer);

        bcx_temp_ans_string_pointer = (char*)calloc( 2048, sizeof(char));

        if (NULL == bcx_temp_ans_string_pointer)
        {
            bcx_last_com_HRESULT =  E_OUTOFMEMORY;
            bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("Mem Allocation of temp_char_variable Failed in CoInitializeEx!"));
            return;
        }

        bcx_temp_ans_string_buffer_size =  2048;

        return;
    }
    else
    {
        bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("CoInitializeEx Failed!"));
    }
}


void  bcx_ole_uninitialize(void)
{
    if (bcx_ole_objects_count)
    {
        _TCHAR ermm[cSizeOfDefaultString];
        wsprintf(ermm, _T("Check BCX Set Nothing Statement!\nNumber of objects not released: %d"), bcx_ole_objects_count);
        MessageBox(GetActiveWindow(), ermm,  _T("Memory leaks detected!"), MB_OK | MB_ICONWARNING | MB_TASKMODAL);
    }

    BCX_COM_FREE_TEMP_WIDE_STRING();

    BCX_COM_FREE_TEMP_ANSI_STRING();
    CoUninitialize();
}


BOOL BCX_GET_COM_STATUS(OBJECT* object)
{
    if(object)
        return object->pStatus;
    return 0;
}


void BCX_SetNothing(OBJECT* object)
{
    if (!object->pStatus) return;

    bcx_ole_objects_count--;

#ifdef __cplusplus
    if (object->p_unknown) object->p_unknown->Release();

#else
    if (object->p_unknown) object->p_unknown->lpVtbl->Release(object->p_unknown);

#endif
    if (object->ipointer)
    {
        bcx_reset_dispatch_chain(object);
        object->ipointer = 0;
    }

    bcx_last_com_HRESULT = VariantClear(&object->pObjects[0]);

    if (FAILED(bcx_last_com_HRESULT))
    {
        lstrcpy(bcx_last_com_error_indicator, _T("BCX_SetNothing Failed!"));
        bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("Release of objects IDispatch interface failed!"));
    }

    object->pStatus = FALSE;

    Sleep(100);
}


void bcx_catch_hr_error_desc(HRESULT hr, const _TCHAR* extra_info)
{
    BCX_COM_ERROR = TRUE;
    void* pMsgBuf;
    FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM, NULL, hr, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &pMsgBuf, 0, NULL);
    wsprintf(bcx_last_com_error_holder, _T("COM error code %d (0x%X)\n%s\n%s\nmember: %s"), hr, hr, extra_info, pMsgBuf, bcx_last_com_error_indicator);
    memset(&bcx_last_com_error_indicator, 0, sizeof(bcx_last_com_error_indicator));

    if (bSHOW_BCX_COM_ERROR)
    {
        MessageBox(GetActiveWindow(), bcx_last_com_error_holder, _T("BCX COM parser, error report:"), MB_OK | MB_ICONERROR | MB_SYSTEMMODAL);
    }

    LocalFree(pMsgBuf);
}


void  bcx_build_exception_info(HRESULT hr,  EXCEPINFO* pexcep, UINT uiArgErr)
{
    SCODE oleSCODE;
    static _TCHAR lv_message[cSizeOfDefaultString];
    oleSCODE = GetScode(hr);

    for (;;)
    {
        if (oleSCODE == DISP_E_PARAMNOTFOUND)
        {
            wsprintf(lv_message, _T("\nArgument not found, argument %d."), uiArgErr);
            _tcscat(bcx_last_com_error_holder, lv_message);
            break;
        }

        if (oleSCODE == DISP_E_TYPEMISMATCH)
        {
            wsprintf(lv_message, _T("\nType mismatch, argument %d."), uiArgErr);
            _tcscat(bcx_last_com_error_holder, lv_message);
            break;
        }

        if (oleSCODE == DISP_E_BADVARTYPE)
        {
            _tcscat(bcx_last_com_error_holder, _T("\nOne or more of the arguments passed in isn't a valid VARIANT type."));
            break;
        }

        if (oleSCODE == E_INVALIDARG)
        {
            _tcscat(bcx_last_com_error_holder, _T("\nOne of the arguments is invalid."));
            break;
        }

        break;
    }

    if (pexcep)
    {
        wsprintf(lv_message, _T("\nCOM Error %X:"), pexcep->wCode);

        if (pexcep->bstrDescription)
        {
            _TCHAR err_desc[512];
#ifndef UNICODE
            bcx_last_com_HRESULT = BCX_COM_WS2AS(pexcep->bstrDescription, CP_ACP);

            if (FAILED(bcx_last_com_HRESULT))
            {
                bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("Get Error Description Failed! Wide to ANSI conversion failure!"));
            }
            else
            {
                wsprintf(err_desc, _T("\nException desc: %s"), bcx_temp_ans_string_pointer);
            }

#else
            wsprintf(err_desc, _T("\nException desc: %s"), pexcep->bstrDescription);

#endif
            _tcscat(lv_message, err_desc);

            SysFreeString(pexcep->bstrDescription);

            pexcep->bstrDescription = NULL;
        }

        if (pexcep->bstrSource)
        {
            _TCHAR err_desc[512];
#ifndef UNICODE
            bcx_last_com_HRESULT = BCX_COM_WS2AS(pexcep->bstrSource, CP_ACP);

            if (FAILED(bcx_last_com_HRESULT))
            {
                bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("Get Error Source Failed! Wide to ANSI conversion failure!"));
            }
            else
            {
                wsprintf(err_desc, _T("\nException source: %s"), bcx_temp_ans_string_pointer);
            }

#else
            wsprintf(err_desc, _T("\nException source: %s"), pexcep->bstrSource);

#endif
            _tcscat(lv_message, err_desc);

            SysFreeString(pexcep->bstrSource);

            pexcep->bstrSource = NULL;
        }

        if (pexcep->bstrHelpFile)
        {
            _TCHAR err_desc[512];
#ifndef UNICODE
            bcx_last_com_HRESULT = BCX_COM_WS2AS(pexcep->bstrHelpFile, CP_ACP);

            if (FAILED(bcx_last_com_HRESULT))
            {
                bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("Get Help File Info Failed! Wide to ANSI conversion failure!"));
            }
            else
            {
                wsprintf(err_desc, _T("\nHelp file: %s | topic: %lu"), bcx_temp_ans_string_pointer, pexcep->dwHelpContext);
            }

#else
            wsprintf(err_desc, _T("\nHelp file: %s | topic: %lu"), pexcep->bstrHelpFile, pexcep->dwHelpContext);
#endif
            _tcscat(lv_message, err_desc);

            SysFreeString(pexcep->bstrHelpFile);

            pexcep->bstrHelpFile = NULL;
        }

        _tcscat(bcx_last_com_error_holder , lv_message);
    }

    if (bSHOW_BCX_COM_ERROR)
    {
        MessageBox(NULL, bcx_last_com_error_holder, _T("BCX COM pareser, Exception Info:"), MB_OK | MB_ICONERROR | MB_SYSTEMMODAL);
    }
}


DISPID bcx_get_DISPID_of_dispatch(IDispatch* lpDispatch, LPOLESTR comsegment)
{
    static DISPID D_ID;
    D_ID = 0;

    if (!lpDispatch) return -1;

#ifdef __cplusplus
    bcx_last_com_HRESULT = lpDispatch->GetIDsOfNames(IID_NULL, &comsegment, 1, LOCALE_SYSTEM_DEFAULT, &D_ID);

#else
    bcx_last_com_HRESULT = lpDispatch->lpVtbl->GetIDsOfNames(lpDispatch, &IID_NULL, &comsegment, 1, LOCALE_SYSTEM_DEFAULT, &D_ID);

#endif
    if (FAILED(bcx_last_com_HRESULT))
    {
        bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("Unrecognized member name"));
        return -1;
    }

    return D_ID;
}


void  bcx_get_next_dispatch(OBJECT* object, LPOLESTR comsegment)
{
    if (!object->pStatus) return;

    if (0 == object->ipointer) BCX_COM_ERROR = FALSE;

    if (BCX_COM_ERROR) return;

    bcx_force_reset_chain++;

    bcx_invoke_helper(object, comsegment, DISPATCH_PROPERTYGET | DISPATCH_METHOD, &object->pObjects[object->ipointer + 1]);

    bcx_force_reset_chain--;

    if (!BCX_COM_ERROR)
    {
        object->ipointer++;
    }
}


void bcx_invoke_helper(OBJECT* object, const LPOLESTR comsegment, WORD wFlags, VARIANT *pvResult)
{
    if (!object->pStatus) return;

    if (BCX_COM_ERROR) return;

    DISPID lv_DID;

    EXCEPINFO exception;

    UINT argerr = 0;

    DISPPARAMS dp = {NULL, NULL, 0, 0 };

    WORD invoke_flags = 0;

    DISPID setdispid = DISPID_PROPERTYPUT;

    if (bcx_com_get_enumerator_intf)
    {
        lv_DID = DISPID_NEWENUM;
    }
    else
    {
        lv_DID = bcx_get_DISPID_of_dispatch(object->pObjects[object->ipointer].pdispVal, comsegment);

        if (-1 == lv_DID) goto cleanInProp;
    }

    memset(&exception, 0, sizeof(EXCEPINFO));

    if (bcx_param_list_index_p > 0)
    {
        setdispid = DISPID_PROPERTYPUT;
        dp.rgvarg = (VARIANTARG*)bcx_static_param_list.pParams;
    }

    if (wFlags & DISPATCH_PROPERTYPUT)
    {
        dp.rgdispidNamedArgs = &setdispid;
        dp.cNamedArgs = 1;
    }

    dp.cArgs = bcx_param_list_index_p;

    invoke_flags = wFlags;

    if (wFlags & DISPATCH_PROPERTYGET)
    {
        if (pvResult) VariantInit(pvResult);
    }

    if (VT_DISPATCH != object->pObjects[object->ipointer].vt || NULL == object->pObjects[object->ipointer].pdispVal)
    {
        bcx_last_com_HRESULT = E_NOINTERFACE;
        bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("bcx_invoke_helper::Invalid IDispatch interface."));
        goto cleanInProp;
    }

#ifdef __cplusplus
    bcx_last_com_HRESULT = object->pObjects[object->ipointer].pdispVal->Invoke(lv_DID, IID_NULL, LOCALE_SYSTEM_DEFAULT, invoke_flags , &dp, pvResult, &exception, &argerr);

#else
    bcx_last_com_HRESULT = object->pObjects[object->ipointer].pdispVal->lpVtbl->Invoke(object->pObjects[object->ipointer].pdispVal, lv_DID, &IID_NULL, LOCALE_SYSTEM_DEFAULT, invoke_flags , &dp, pvResult, &exception, &argerr);

#endif
    if (FAILED(bcx_last_com_HRESULT))
    {
        bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("bcx_invoke_helper::Invoke failed."));
        bcx_build_exception_info(bcx_last_com_HRESULT, &exception, argerr);
    }

cleanInProp:

    if (V_ISARRAY(&bcx_static_param_list.pParams[0]))
    {
        if ((VT_ARRAY | VT_VARIANT) == bcx_static_param_list.pParams[0].vt)
        {
            bcx_last_com_HRESULT = SafeArrayDestroy(V_ARRAY(&bcx_static_param_list.pParams[0]));

            if (FAILED(bcx_last_com_HRESULT))
            {
                lstrcpy(bcx_last_com_error_indicator, _T("SafeArrayDestroy failed"));
                bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("Error while cleaning parameter list."));
            }

            ZeroMemory((PVOID)&bcx_static_param_list.pParams[0], sizeof(VARIANT));

            bcx_safe_array_pointer_psa = NULL;
            bcx_param_list_index_p = 0;
        }
    }

    if (bcx_param_list_index_p)  bcx_clean_parameter_list();

    if (0 == bcx_force_reset_chain) bcx_reset_dispatch_chain(object);
}


void  bcx_clean_parameter_list(void)
{
    int total_parms = bcx_param_list_index_p;

    if (bcx_param_list_index_p > 0)
    {
        do
        {
            bcx_last_com_HRESULT = VariantClear(&bcx_static_param_list.pParams[bcx_param_list_index_p - 1]);

            if (FAILED(bcx_last_com_HRESULT))
            {
                wsprintf(bcx_last_com_error_indicator, _T("\nVariant type = %d, at index %d, total params = %d."), bcx_static_param_list.pParams[bcx_param_list_index_p - 1].vt, bcx_param_list_index_p - 1, total_parms);
                bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("Error while cleaning parameter list."));
            }

            bcx_param_list_index_p--;
        }
        while (bcx_param_list_index_p > 0);
    }
}


void  bcx_reset_dispatch_chain(OBJECT* object)
{
    if (object->ipointer > bcx_preserve_dispatch_at_offset)
    {
        do
        {
            VariantClear(&object->pObjects[object->ipointer]);
            object->ipointer--;
        }
        while (object->ipointer > bcx_preserve_dispatch_at_offset);
    }
}


/* <--UNICODE AWARE-->  */
/* <--UNICODE AWARE-->  */
void BCX_CreateObject(_TCHAR* objname, OBJECT* obj)
{
    if (!bcx_ole_initialized) bcx_ole_initialize();

    CLSID clsid;

#ifndef UNICODE
    bcx_last_com_HRESULT = BCX_COM_AS2WS(objname, CP_ACP);

    if (FAILED(bcx_last_com_HRESULT))
    {
        bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("CreateObject Failed! ANSI to Wide conversion failure!"));
        return;
    }

    bcx_last_com_HRESULT = BCX_COM_WS2AS(bcx_temp_wide_string_pointer, CP_ACP);

    if (FAILED(bcx_last_com_HRESULT))
    {
        bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("CreateObject Failed! Wide to ANSI conversion failure!"));
        return;
    }

    sprintf(bcx_last_com_error_indicator, "%s, WideName(%s)", objname, bcx_temp_ans_string_pointer);

    bcx_last_com_HRESULT = CLSIDFromProgID((LPCOLESTR)bcx_temp_wide_string_pointer, (LPCLSID)&clsid);
#else
    lstrcpy(bcx_last_com_error_indicator, objname);
    bcx_last_com_HRESULT = CLSIDFromProgID((LPCOLESTR)objname, (LPCLSID)&clsid);
#endif

    if (FAILED(bcx_last_com_HRESULT))
    {
        bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("CLSIDFromProgID failed!"));
        return;
    }

#ifdef __cplusplus
    bcx_last_com_HRESULT = CoCreateInstance((REFCLSID)clsid, NULL,  CLSCTX_INPROC_SERVER | CLSCTX_LOCAL_SERVER , IID_IUnknown, (void **)&obj->p_unknown);

#else
    bcx_last_com_HRESULT = CoCreateInstance((REFCLSID)&clsid, NULL, CLSCTX_INPROC_SERVER | CLSCTX_LOCAL_SERVER , &IID_IUnknown, (void **)&obj->p_unknown);

#endif
    if (FAILED(bcx_last_com_HRESULT))
    {
        bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("CoCreateInstance failed!"));
    }
    else
    {
        VariantInit(&obj->pObjects[0]);
        obj->pObjects[0].vt = VT_DISPATCH;
#ifdef __cplusplus
        bcx_last_com_HRESULT = obj->p_unknown->QueryInterface(IID_IDispatch, (void **)&obj->pObjects[0].pdispVal);
#else
        bcx_last_com_HRESULT = obj->p_unknown->lpVtbl->QueryInterface(obj->p_unknown, &IID_IDispatch, (void **)&obj->pObjects[0].pdispVal);
#endif
    }

    if (FAILED(bcx_last_com_HRESULT))
    {
        bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("QueryInterface::IID_IDispatch  failed!"));
        obj->pObjects[0].vt = VT_NULL;
        VariantClear(&obj->pObjects[0]);
#ifdef __cplusplus
        obj->p_unknown->Release();
#else
        obj->p_unknown->lpVtbl->Release(obj->p_unknown);
#endif
    }
    else
    {
        obj->pStatus = TRUE;
        obj->ipointer = 0;
        bcx_ole_objects_count++;
    }
}


/* >--UNICODE AWARE--<  */
/* <--UNICODE AWARE-->  */
HRESULT BCX_COM_WS2AS(LPCWSTR wide_string, UINT code_page)
{
    if (wide_string == NULL) return (HRESULT) NO_ERROR;

    ULONG temp_bytes_copied_len = 0;

    ULONG temp_ansi_len = (ULONG)WideCharToMultiByte(code_page, 0, wide_string, -1, bcx_temp_ans_string_pointer, 0, NULL, NULL) + 256;

    if (temp_ansi_len == 0) return (HRESULT) NO_ERROR;

    if (bcx_temp_ans_string_buffer_size < temp_ansi_len)
    {
        if (bcx_temp_ans_string_pointer) free(bcx_temp_ans_string_pointer);

        bcx_temp_ans_string_pointer = (char*)calloc(temp_ansi_len, sizeof(char));

        if (NULL == bcx_temp_ans_string_pointer)
        {
            bcx_temp_ans_string_buffer_size = 0;
            return E_OUTOFMEMORY;
        } // if

        bcx_temp_ans_string_buffer_size = temp_ansi_len;
    }

    if ((temp_bytes_copied_len = WideCharToMultiByte(code_page, 0, wide_string, -1, bcx_temp_ans_string_pointer, temp_ansi_len, NULL, NULL)) == 0)
    {
        return HRESULT_FROM_WIN32(GetLastError());
    } // if

    bcx_temp_ans_string_pointer[temp_bytes_copied_len] = '\0';

    return (HRESULT)NO_ERROR;
}


HRESULT BCX_COM_AS2WS(LPCSTR ansi_string, UINT code_page)
{
    if (!*ansi_string) return (HRESULT)NO_ERROR;

    ULONG ansi_str_len = strlen(ansi_string);

    if (!ansi_str_len) return (HRESULT)NO_ERROR;

    ULONG wide_str_len = (ansi_str_len * 2) + 256;

    if (bcx_temp_wide_string_buffer_size < wide_str_len)
    {
        if (bcx_temp_wide_string_pointer) CoTaskMemFree((void*)bcx_temp_wide_string_pointer);

        bcx_temp_wide_string_pointer = (LPOLESTR)CoTaskMemAlloc(wide_str_len);

        if (NULL == bcx_temp_wide_string_pointer)
        {
            bcx_temp_wide_string_buffer_size = 0;
            return E_OUTOFMEMORY;
        } // if

        bcx_temp_wide_string_buffer_size = wide_str_len;
    }

    if (MultiByteToWideChar(code_page, MB_PRECOMPOSED, ansi_string, ansi_str_len, bcx_temp_wide_string_pointer, wide_str_len) == 0)
    {
        return HRESULT_FROM_WIN32(GetLastError());
    } // if

    bcx_temp_wide_string_pointer[ansi_str_len] = L'\0';

    return (HRESULT)NO_ERROR;
}


void BCX_COM_FREE_TEMP_WIDE_STRING(void)
{
    if (bcx_temp_wide_string_pointer)
    {
        CoTaskMemFree((void*)bcx_temp_wide_string_pointer);
        bcx_temp_wide_string_pointer = NULL;
    }
}


void BCX_COM_FREE_TEMP_ANSI_STRING(void)
{
    if (bcx_temp_ans_string_pointer)
    {
        free(bcx_temp_ans_string_pointer);
        bcx_temp_ans_string_pointer = NULL;
    }
}


/* >--UNICODE AWARE--<  */

// *************************************************
//       User Subs, Functions and Class Methods
// *************************************************

// *************************************************
//                  Main Program
// *************************************************

int main(int argc, char *argv[])
{
    g_argc = argc;
    g_argv = argv;
    BCX_CreateObject("Wscript.Shell", &objShell);

    lstrcpy(bcx_last_com_error_indicator, _T("SpecialFolders(\"AllUsersPrograms\")"));
    bcx_static_param_list.pParams[0].vt = VT_BSTR;
    bcx_static_param_list.pParams[0].bstrVal = SysAllocString(L"AllUsersPrograms");
    bcx_param_list_index_p =  1;
    bcx_invoke_helper(&objShell, L"SpecialFolders", DISPATCH_PROPERTYGET | DISPATCH_METHOD, &bcx_temp_result_variant);
    if(bcx_temp_result_variant.vt == VT_NULL) {
        *str1 = 0;
    } else {
        bcx_last_com_HRESULT = VariantChangeType(&bcx_temp_result_variant, &bcx_temp_result_variant, 0, VT_BSTR);
        if (FAILED(bcx_last_com_HRESULT)) {
            bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("VariantChangeType (BSTR) Failed!"));
        } else {
#ifndef UNICODE
            bcx_last_com_HRESULT = BCX_COM_WS2AS(bcx_temp_result_variant.bstrVal, CP_ACP);
            if (FAILED(bcx_last_com_HRESULT)) {
                bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("COM Get Property Failed! Wide to ANSI conversion failure!"));
            } else {
                strcpy(str1, bcx_temp_ans_string_pointer);
            }
#else
            lstrcpy(str1, bcx_temp_result_variant.bstrVal);
#endif
        }
    }
    VariantClear(&bcx_temp_result_variant);
    if (0 == bcx_force_reset_chain) bcx_reset_dispatch_chain(&objShell);
    strcpy(strTargetPathx86, join(2, str1, "\\Visual Studio 2017\\Visual Studio Tools\\VC\\x86 Native Tools Command Prompt for VS 2017.lnk"));
    strcpy(strTargetPathx64, join(2, str1, "\\Visual Studio 2017\\Visual Studio Tools\\VC\\x64 Native Tools Command Prompt for VS 2017.lnk"));
    BCX_SetNothing(&objShell);
    if(Exist(strTargetPathx86))
    {
        BCX_CreateObject("Wscript.Shell", &objShell);

        lstrcpy(bcx_last_com_error_indicator, _T("CreateShortcut(strTargetPathx86$)"));
        bcx_last_com_HRESULT = BCX_COM_AS2WS(strTargetPathx86, CP_ACP);
        if (FAILED(bcx_last_com_HRESULT)) {
            bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("Build ParamList Failed! ANSI to Wide conversion failure!"));
        } else {
            bcx_static_param_list.pParams[0].vt = VT_BSTR;
            bcx_static_param_list.pParams[0].bstrVal = SysAllocString(bcx_temp_wide_string_pointer);
        }
        bcx_param_list_index_p =  1;
        bcx_invoke_helper(&objShell, L"CreateShortcut", DISPATCH_PROPERTYGET | DISPATCH_METHOD, &bcx_temp_result_variant);
        if (bcx_temp_result_variant.vt != VT_DISPATCH) {
            bcx_last_com_HRESULT = VariantChangeType(&bcx_temp_result_variant, &bcx_temp_result_variant, 0, VT_DISPATCH);
        }
        if (FAILED(bcx_last_com_HRESULT)) {
            strcpy(bcx_last_com_error_indicator , "objShortcut");
            bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("VariantChangeType failed. Expected IDIspatch*"));
        } else {
            VariantInit(&objShortcut.pObjects[0]);
            bcx_last_com_HRESULT = VariantCopy(&objShortcut.pObjects[0], &bcx_temp_result_variant);
            if (FAILED(bcx_last_com_HRESULT)) {
                strcpy(bcx_last_com_error_indicator , "objShortcut");
                bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("VariantCopy failed."));
            } else {
                bcx_ole_objects_count++;
                objShortcut.pStatus = TRUE;
                objShortcut.ipointer = 0;
            }  // if
        } // if
        VariantClear(&bcx_temp_result_variant);
        if (0 == bcx_force_reset_chain) bcx_reset_dispatch_chain(&objShell);

        lstrcpy(bcx_last_com_error_indicator, _T("WorkingDirectory"));
        bcx_invoke_helper(&objShortcut, L"WorkingDirectory", DISPATCH_PROPERTYGET | DISPATCH_METHOD, &bcx_temp_result_variant);
        if(bcx_temp_result_variant.vt == VT_NULL) {
            *str1 = 0;
        } else {
            bcx_last_com_HRESULT = VariantChangeType(&bcx_temp_result_variant, &bcx_temp_result_variant, 0, VT_BSTR);
            if (FAILED(bcx_last_com_HRESULT)) {
                bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("VariantChangeType (BSTR) Failed!"));
            } else {
#ifndef UNICODE
                bcx_last_com_HRESULT = BCX_COM_WS2AS(bcx_temp_result_variant.bstrVal, CP_ACP);
                if (FAILED(bcx_last_com_HRESULT)) {
                    bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("COM Get Property Failed! Wide to ANSI conversion failure!"));
                } else {
                    strcpy(str1, bcx_temp_ans_string_pointer);
                }
#else
                lstrcpy(str1, bcx_temp_result_variant.bstrVal);
#endif
            }
        }
        VariantClear(&bcx_temp_result_variant);
        if (0 == bcx_force_reset_chain) bcx_reset_dispatch_chain(&objShortcut);
        strcpy(SWorkx86, enc(str1,  0,  0));

        lstrcpy(bcx_last_com_error_indicator, _T("Arguments"));
        bcx_invoke_helper(&objShortcut, L"Arguments", DISPATCH_PROPERTYGET | DISPATCH_METHOD, &bcx_temp_result_variant);
        if(bcx_temp_result_variant.vt == VT_NULL) {
            *str1 = 0;
        } else {
            bcx_last_com_HRESULT = VariantChangeType(&bcx_temp_result_variant, &bcx_temp_result_variant, 0, VT_BSTR);
            if (FAILED(bcx_last_com_HRESULT)) {
                bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("VariantChangeType (BSTR) Failed!"));
            } else {
#ifndef UNICODE
                bcx_last_com_HRESULT = BCX_COM_WS2AS(bcx_temp_result_variant.bstrVal, CP_ACP);
                if (FAILED(bcx_last_com_HRESULT)) {
                    bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("COM Get Property Failed! Wide to ANSI conversion failure!"));
                } else {
                    strcpy(str1, bcx_temp_ans_string_pointer);
                }
#else
                lstrcpy(str1, bcx_temp_result_variant.bstrVal);
#endif
            }
        }
        VariantClear(&bcx_temp_result_variant);
        if (0 == bcx_force_reset_chain) bcx_reset_dispatch_chain(&objShortcut);
        strcpy(SArgux86, remain(str1, "/k "));
        BCX_SetNothing(&objShortcut);
        BCX_SetNothing(&objShell);
    }
    if(Exist(strTargetPathx64))
    {
        BCX_CreateObject("Wscript.Shell", &objShell);

        lstrcpy(bcx_last_com_error_indicator, _T("CreateShortcut(strTargetPathx64$)"));
        bcx_last_com_HRESULT = BCX_COM_AS2WS(strTargetPathx64, CP_ACP);
        if (FAILED(bcx_last_com_HRESULT)) {
            bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("Build ParamList Failed! ANSI to Wide conversion failure!"));
        } else {
            bcx_static_param_list.pParams[0].vt = VT_BSTR;
            bcx_static_param_list.pParams[0].bstrVal = SysAllocString(bcx_temp_wide_string_pointer);
        }
        bcx_param_list_index_p =  1;
        bcx_invoke_helper(&objShell, L"CreateShortcut", DISPATCH_PROPERTYGET | DISPATCH_METHOD, &bcx_temp_result_variant);
        if (bcx_temp_result_variant.vt != VT_DISPATCH) {
            bcx_last_com_HRESULT = VariantChangeType(&bcx_temp_result_variant, &bcx_temp_result_variant, 0, VT_DISPATCH);
        }
        if (FAILED(bcx_last_com_HRESULT)) {
            strcpy(bcx_last_com_error_indicator , "objShortcut");
            bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("VariantChangeType failed. Expected IDIspatch*"));
        } else {
            VariantInit(&objShortcut.pObjects[0]);
            bcx_last_com_HRESULT = VariantCopy(&objShortcut.pObjects[0], &bcx_temp_result_variant);
            if (FAILED(bcx_last_com_HRESULT)) {
                strcpy(bcx_last_com_error_indicator , "objShortcut");
                bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("VariantCopy failed."));
            } else {
                bcx_ole_objects_count++;
                objShortcut.pStatus = TRUE;
                objShortcut.ipointer = 0;
            }  // if
        } // if
        VariantClear(&bcx_temp_result_variant);
        if (0 == bcx_force_reset_chain) bcx_reset_dispatch_chain(&objShell);

        lstrcpy(bcx_last_com_error_indicator, _T("WorkingDirectory"));
        bcx_invoke_helper(&objShortcut, L"WorkingDirectory", DISPATCH_PROPERTYGET | DISPATCH_METHOD, &bcx_temp_result_variant);
        if(bcx_temp_result_variant.vt == VT_NULL) {
            *str1 = 0;
        } else {
            bcx_last_com_HRESULT = VariantChangeType(&bcx_temp_result_variant, &bcx_temp_result_variant, 0, VT_BSTR);
            if (FAILED(bcx_last_com_HRESULT)) {
                bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("VariantChangeType (BSTR) Failed!"));
            } else {
#ifndef UNICODE
                bcx_last_com_HRESULT = BCX_COM_WS2AS(bcx_temp_result_variant.bstrVal, CP_ACP);
                if (FAILED(bcx_last_com_HRESULT)) {
                    bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("COM Get Property Failed! Wide to ANSI conversion failure!"));
                } else {
                    strcpy(str1, bcx_temp_ans_string_pointer);
                }
#else
                lstrcpy(str1, bcx_temp_result_variant.bstrVal);
#endif
            }
        }
        VariantClear(&bcx_temp_result_variant);
        if (0 == bcx_force_reset_chain) bcx_reset_dispatch_chain(&objShortcut);
        strcpy(SWorkx64, enc(str1,  0,  0));

        lstrcpy(bcx_last_com_error_indicator, _T("Arguments"));
        bcx_invoke_helper(&objShortcut, L"Arguments", DISPATCH_PROPERTYGET | DISPATCH_METHOD, &bcx_temp_result_variant);
        if(bcx_temp_result_variant.vt == VT_NULL) {
            *str1 = 0;
        } else {
            bcx_last_com_HRESULT = VariantChangeType(&bcx_temp_result_variant, &bcx_temp_result_variant, 0, VT_BSTR);
            if (FAILED(bcx_last_com_HRESULT)) {
                bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("VariantChangeType (BSTR) Failed!"));
            } else {
#ifndef UNICODE
                bcx_last_com_HRESULT = BCX_COM_WS2AS(bcx_temp_result_variant.bstrVal, CP_ACP);
                if (FAILED(bcx_last_com_HRESULT)) {
                    bcx_catch_hr_error_desc(bcx_last_com_HRESULT, _T("COM Get Property Failed! Wide to ANSI conversion failure!"));
                } else {
                    strcpy(str1, bcx_temp_ans_string_pointer);
                }
#else
                lstrcpy(str1, bcx_temp_result_variant.bstrVal);
#endif
            }
        }
        VariantClear(&bcx_temp_result_variant);
        if (0 == bcx_force_reset_chain) bcx_reset_dispatch_chain(&objShortcut);
        strcpy(SArgux64, remain(str1, "/k "));
        BCX_SetNothing(&objShortcut);
        BCX_SetNothing(&objShell);
    }
    printf("%s%s\n", "32 bit Working Directory ", SWorkx86);
    printf("%s%s\n", "32 bit Arguments ", SArgux86);
    printf("%s%s\n", "64 bit Working Directory ", SWorkx64);
    printf("%s%s\n", "64 bit Arguments ", SArgux64);
    Pause();
    return 0;   /* End of main program */
}

